CC := gcc
CXX := g++
CXXFLAGS += -O2 -I ./include/tasks -I ./include/runnables -I ./include/utils -I ./lib/fred -I ./lib/fred/fred_support 
# comment this line to remove all debug messages. useful for performance measurements.
CXXFLAGS += -DDEBUG
# uncomment this for even more debug messages
#CXXFLAGS += -DDEBUG_EXTRA
# add here warning flags to be ignored
CXXFLAGS += -Wno-unused-command-line-argument -Wno-deprecated-register
CFLAGS = $(CXXFLAGS)
LDFLAGS += -L./lib/fred/ -lpthread -lfred -fopenmp

bin = synthetic
csrc = $(wildcard src/*.c) \
       $(wildcard src/utils/*.c) \
       $(wildcard src/tasks/*.c) \
       $(wildcard src/runnables/*.c)
ccsrc = $(wildcard src/*.cpp) \
        $(wildcard src/utils/*.cpp) \
        $(wildcard src/tasks/*.cpp) \
        $(wildcard src/runnables/*.cpp)
obj = $(csrc:.c=.o) $(ccsrc:.cpp=.o)

$(bin): $(obj)
	make -C ./lib/fred/ CC=$(CC)
	$(CXX) $(CXXFLAGS) $^ -o $@ $(LDFLAGS)

clean:
	make -C ./lib/fred/ clean
	rm -f $(bin) $(obj)
